//MyProperty.h

//http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2004/n1615.pdf

#ifndef _MYPROPERTY_H
#define _MYPROPERTY_H

#include <string>
//#include <iostream>
#include "PropertyType.h"

//̽ ø  ν Property ̳ʿ  ִ.
class IProperty
{
public:
    IProperty( const std::string& name ) : m_name( name )
    {
    }
    virtual ~IProperty()
    {
    }
    const std::string& GetName() const
    {
        return m_name;
    }
    virtual const char* GetTypeName() const = 0;
    virtual ePropertyType GetType() const = 0;
    virtual void* GetData() = 0;
protected:
    std::string     m_name;
};

template<typename T>
class MyProperty : public IProperty
{
public:
    MyProperty( const std::string& name ) : IProperty( name )
    {
    }
    virtual ~MyProperty()
    {
    }
    ePropertyType GetType() const
    {
        return PropertyType<T>::GetTypeID();
    }
    const char* GetTypeName() const
    {
        return PropertyType<T>::GetTypeName();
    }
    virtual void* GetData()
    {
        return &m_data;
    }
    T& GetValue()
    {
        return m_data;
    }

    friend std::ostream& operator << (std::ostream& os, const MyProperty<T>& v)
    {
        os << v.m_data;
        return os;
    }

    T& operator= (const T& value)
    {
        return m_data = value;
    }
    operator T() const
    {
        return m_data;
    }
    
protected:
    T   m_data;
};

#endif